// -*-C++-*-
//
// File:      OmSourceBrowser.cc
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Sep  6 11:14:45 MEST 2002
// Usage:     
// Info:      -
// Omsource header files
#include <qcursor.h>


// QT header files
#include <qapplication.h>

#include <cstring>
#include <qlistbox.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qspinbox.h> 
#include <qstatusbar.h>
#include <qprogressbar.h>
#include <qstring.h>
#include <qtooltip.h>
#include <qinputdialog.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qfiledialog.h>
#include <qprinter.h> 
#include <qpainter.h>
#include <qfont.h> 
#include <qpaintdevicemetrics.h> 
#include <qdatetime.h>
#include <qlayout.h>
#include <qmenubar.h>
#include <qprocess.h>
#include <qsettings.h>
#include <qstringlist.h>
#include <qfileinfo.h>
#include <qwhatsthis.h>
#include "allocate.h"
#include <iostream>
#include <qimage.h>
#include <qtimer.h>

#include "OmSourceParameters.h"
#include "OmSourceVersionNo.h"
#include "OmSourceBrowser.h"
#include "OmSourceRegions.h"
#include "OmImageDisplay.h"
#include "OmProgressDialog.h"
#include "OmSourceLog.h"
#include "OmSourceNumerics.h"

#include "OmSourceDetectDialog.h"
#include "OmSourcePhotometryDlg.h"
#include "OmFastPhotometryDlg.h"

//#include "OmSourceDeconvolveDlg.h"
#include "OmSourceInformationDlg.h"
#include "OmSourceProcessDlg.h"
//#include "OmSourceHistoryDlg.h"
#include "OmSourceTableDlg.h"
#include "OmSourceAddSourcesDlg.h"
#include "OmSourceLabel.h"
#include "OmSpinBox.h"

// OM header files
#include <omdetect.h>

#include <omatt.h>
// Other SAS header files
#include <Dal.h>

#include <ExceptionErrorHandler.h>
#include <param.h>
#include <errstr.h>
#include "AngleFormatter.h"



#include "OmSourceUtility.h"
#include "OmSourceButton.h"
#include "OmSourceEdit.h"
#include "OmSourceGroupBox.h"
#include "OmSourceInformationMenu.h"
#include "OmSourceHelp.h"
#include "OmSourceRegions.h"
#include "OmSourceTempFile.h"

// --- Glue prototypes ---
extern F90MODVARDEF(OmSourceParameters, omsource_glue, mysources);
extern F90MODVARDEF(PhotometryParameters, omsource_glue, myphotometryparameters);
extern F90MODVARDEF(float, omsource_glue, mycalradius);

F90MODPROCPROTO(void, omsource_glue, init)(bool &loaded);
F90MODPROCPROTO(void, omsource_glue, replace)(const int& id, const OmSourceParameter&);
F90MODPROCPROTO(void, omsource_glue, finish)();
F90MODPROCPROTO(void, omsource_glue, computebackground)(float &value, float &error);
F90MODPROCPROTO(void, omsource_glue, computejuliandates)(double &JD1, double &JD2, double &JD3);
F90MODPROCPROTO(void,omsource_glue, loadsources)();
F90MODPROCPROTO(void,omsource_glue, deletelist)();
F90MODPROCPROTO(void,omsource_glue, recompute)(const int& id);
F90MODPROCPROTO(void,omsource_glue, remove)(const int& id);
F90MODPROCPROTO(void,omsource_glue, addregions)(OmSourceRegions*);
F90MODPROCPROTO(void, omsource_glue, loadimage)(float**);
 

//float** LoadImage(char *fileName, int &nx, int &ny);

F90MODPROCPROTO(void, omsource_glue, test1)(int size, float *data);




//string OmSourceBrowser::_oldRegionsColour = "green"; 
 string OmSourceBrowser::_oldRegionsColour = "Colour dependent on extension- DEFAULT"; 



string OmSourceBrowser::_newRegionsColour = "blue";
string OmSourceBrowser::_backgroundRegionsColour = "cyan";

vector<string> OmSourceBrowser::_colourList; 

int OmSourceBrowser::_oldRegionsNo = 8;
int OmSourceBrowser:: _newRegionsNo = 5;
int OmSourceBrowser:: _backgroundRegionsNo = 6;



/*******************************************************
* constructor
* This is the main widget of the application*
******************************************************/
OmSourceBrowser::OmSourceBrowser(QWidget* parent, const char* name) : 
  QWidget(parent, name), _sourceNo(0), _sourceListHasChanged(false),  
  _sourceListIsLoaded(false)
{ 
   
  


    _colourList.push_back("white");
    _colourList.push_back("black");
    _colourList.push_back("red" );
    _colourList.push_back("green" );
    _colourList.push_back( "blue" );
    _colourList.push_back( "cyan" );


    //    _colourList.push_back( "magenta" );
    //    _colourList.push_back( "yellow" );
    _colourList.push_back( _oldRegionsColour );


    OmImageRegions::setColour( "yellow" );

 
    // Get the name of the image file name
    readFileNames();


    string file = stringParameter("imageset");
   

 

  
    strcpy(_imageFileName, file.c_str()); 
    if (file.length() < 2) 
    {
   
        displayImageFileMenu();
    }

    string text = "Initialising- please wait";

    qApp->processEvents();
 
    
    _reporter = new OmProgressDialog(text, 18);
    
    _reporter->setProgress(1);
   
     // load display
    //    _display = new OmImageDisplay;
     
     _reporter->setProgress(2);
  
 
     //   if (!_display->isUp())
     //    errstr << "Could not launch Imageviewer(ds9)" << Sas::error("NoDisplayer");
    

     // _display->displayImage(_imageFileName);
	    
   
     // _display->send("zoom to fit");
    

     // _display->send("cmap heat"); 
     // _display->send("scale zscale");
     //_display->send("scale linear");
        
     // _display->setNewRegionsColour( _newRegionsColour );


 
    _reporter->setProgress(3);
      
    
    _reporter->setProgress(4);
      
    _changed = FALSE;
   
    
    _reporter->setProgress(5);




    {
      


    OmSourceGroupBox *group = new OmSourceGroupBox( this, 
          "Source list operations", 20, 20, 200, 60, "An operation that is performed on the source-list" );   
						  

    QHBoxLayout* layout = new QHBoxLayout(group);
    
    layout->setMargin(10);
    layout->setSpacing(10);  
   
    _sourceTableBtn = new OmSourceButton(group, "&table",
                "Click here to display the source-list table" );
    
    layout->addWidget( _sourceTableBtn);
    connect(_sourceTableBtn, SIGNAL(clicked()), this, SLOT (showSourceTable()) );
    _sourceTableBtn->setDisabled(TRUE);
   
  

    _reporter->setProgress(11);
 	
  
   
    _deleteListBtn = new OmSourceButton(group, "&delete",
               "Click here to delete the source list");
  
    layout->addWidget( _deleteListBtn);
  
    connect(_deleteListBtn, SIGNAL(clicked()), this, SLOT (deleteList()) );
 

    _deleteListBtn->setDisabled(TRUE);
    _reporter->setProgress(12);





    // For changing region colours




    OmSourceGroupBox *colourBox = new OmSourceGroupBox( this,  "Regions colour", group->geometry().right() + 20, 
                   group->geometry().top(), 70, 25);


 


    /******************************************************************
    * A spin box to set the old regions colour
    *****************************************************************/
   
    _spinBoxColour1 = new OmSpinBox( colourBox, "Change the colour of the regions", _colourList, _oldRegionsNo);

    _spinBoxColour1->setGeometry( 10, 20, 70, 25);

    connect(_spinBoxColour1, SIGNAL(valueChanged(int)), this, SLOT ( oldRegionColourChanged(int)));

    _spinBoxColour1->show();
  
    colourBox->resize( _spinBoxColour1->width() + 30, _spinBoxColour1->height() + 30);





    }




    // create the image buttons
    {
    OmSourceGroupBox* group = new OmSourceGroupBox( this, "Image operations", 
                    20, 100, 300, 60, "Operations involving the whole image" );
 
  
  
    _reporter->setProgress(5);


     QHBoxLayout* layout = new QHBoxLayout( group, QHBoxLayout::LeftToRight);
    
     layout->setMargin(10);
     layout->setSpacing(10);  
    
   
    _viewAllBtn= new OmSourceButton(group, "vie&w all", "Click here to view the whole image");

    
    layout->addWidget(  _viewAllBtn, 1);
    
    _viewAllBtn ->setDisabled(TRUE);
    connect(_viewAllBtn, SIGNAL(clicked()), this, SLOT  (viewAll()));
 

    _reporter->setProgress(6);
 



    // Button for selecting new sources from the image
    _addSourcesBtn = new OmSourceButton(group, "&select sources", 
             "Click here to select additional sources\n"
             "from the image to add to the source list");
 
    layout->addWidget(  _addSourcesBtn, 2);
  
  
    connect(_addSourcesBtn, SIGNAL(clicked()), this, SLOT  (addSources()));
    _reporter->setProgress(7);
 
    _detectSourcesBtn = new OmSourceButton(group, "&omdetect",
               "Click here to run the task omdetect on\n"
               "the image to populate the source list" );
  
    layout->addWidget(  _detectSourcesBtn, 3);
  
 
    connect(_detectSourcesBtn, SIGNAL(clicked()),
    	  this,   SLOT  (detectSources()));
     

    }
   
    // Group box for individual source operations
    {
    OmSourceGroupBox* group = new OmSourceGroupBox( this, "Individual source operations", 
           20, 180, 300, 60, "An operation that is performed on the selected source from the list");


    QHBoxLayout* layout = new QHBoxLayout(group, QHBoxLayout::LeftToRight);
    
    layout->setMargin(10);
    layout->setSpacing(10);  
    

    // The photometry button
    _photometryBtn = new OmSourceButton(group, "&photometry",  
            "Click here to do interactive photometry on the selected source");
    layout->addWidget(_photometryBtn, 1);
 

    _photometryBtn->setDisabled(TRUE);
   
    connect(_photometryBtn, SIGNAL(clicked()), this, SLOT (photometry()));
         

    // The PSF fitting button
    //    _deconSourceBtn = new OmSourceButton(group, "Photometry",  
    //            "Click here to do interactive photometry on the selected source");
    //layout->addWidget(_photometryBtn, 1);
 

    //    _deconSourceBtn->setDisabled(TRUE);
   
    //    connect(_deconSourceBtn, SIGNAL(clicked()), this, SLOT (deconvolveSource()));
         


    // The source deletion button
    _deleteSourceBtn = new OmSourceButton(group, "de&lete", 
         "Click here to delete the selected source");
    layout->addWidget(_deleteSourceBtn, 2);
 
    _deleteSourceBtn->setDisabled(TRUE);
  
    connect(_deleteSourceBtn, SIGNAL(clicked()), this, SLOT (deleteSource()));

    // The source view  button
    _viewSourceBtn = new OmSourceButton(group, "&view", 
                "Click here to zoom in on the source");
  
    layout->addWidget(_viewSourceBtn, 3);
 
  
    _viewSourceBtn->setDisabled(TRUE);
  
    connect(_viewSourceBtn, SIGNAL(clicked()), this, SLOT (displaySource()));

    _reporter->setProgress(8);
  
    // Load the sources (if old sourcelist file specified)
    F90MODPROC(omsource_glue, init)(_sourceListIsLoaded);
 
    _reporter->setProgress(9);
 
  
    _reporter->setProgress(10);
  
  
    }









    /**********************************************************
     * Group box for input files info
     *********************************************************/
    int xPos, yPos;
    {
    OmSourceGroupBox* group = new OmSourceGroupBox( this, "Input files", 
               20, 260, 250, 60, " " );

    QHBoxLayout* layout = new QHBoxLayout(group);
    
    layout->setMargin(10);
    layout->setSpacing(10);  

    _loadImageBtn= new OmSourceButton(group, "&load image", 
             "Click here to select a new image file");    
  
    //    _loadImageBtn->setGeometry(10, 130, 70, 20);
    connect(_loadImageBtn, SIGNAL(clicked()), this, SLOT (loadImage()) );
   
    layout->addWidget( _loadImageBtn);
  
  
    _loadSourceListBtn= new OmSourceButton(group, "load so&urce-list", 
             "Click here to select a new source-list file");    
    
    connect(_loadSourceListBtn, SIGNAL(clicked()), this, SLOT (loadSourceList()) );
    _loadSourceListBtn->setEnabled(!_sourceListIsLoaded);
    
    layout->addWidget(_loadSourceListBtn );
  
    // Information button
    
    yPos = group->geometry().bottom() + 20;
    }
    xPos = 20;
    _informationBtn = new OmSourceButton(this, "&information", xPos, yPos, 25,  
                 "Click here to display observation/image information");    
    connect( _informationBtn, SIGNAL(clicked()), this, SLOT (displayInformation()) );
  




    /*****************************************************************************
    * A help button
    *****************************************************************************/

   
    xPos = _informationBtn->geometry().right() + 10;;
    OmSourceButton *helpButton = new OmSourceButton(this, " &Help ", xPos, yPos, 25, 
               "Click here for help");
  
  
    connect( helpButton, SIGNAL(clicked()), this, SLOT ( showHelpInformation()) );
   
    QToolTip::add( helpButton, "Click here, or click the right mouse-button,\n""for information on the photometry, etc");
  











     
    yPos = _informationBtn->geometry().bottom() + 20;
    _group = new OmSourceGroupBox( this, "Current source", 20, yPos, 290, 280,
        "You select the source from the list for further operations" );   
    
  
    _group->setDisabled(TRUE);
    _reporter->setProgress(13);
   
    xPos = 10;
    yPos = 30;    


    
    
    _reporter->setProgress(14);



    /*****************************************************************************************
    *
    ******************************************************************************************/
    OmSourceLabel *label =
          new OmSourceLabel( _group, "Source no", xPos, yPos, 25, "The selected source for editing.\n"
                          "(The number corresponds to the number on the image.)\n"
			  "Use the spin box to select a diffetent source.");


    int maxWidth = label->geometry().right();

    yPos = label->geometry().bottom() + 20;
    label = new OmSourceLabel( _group, "Image X coordinate", xPos, yPos, 25, "The image pixel X-coordinate of the selected source" );
    maxWidth = max(maxWidth, label->geometry().right());

    yPos = label->geometry().bottom() + 5;
    label = new OmSourceLabel( _group, "Image Y coordinate", xPos, yPos, 25,  "The image pixel Y-coordinate of the selected source" );
    maxWidth = max(maxWidth, label->geometry().right());

    yPos = label->geometry().bottom() + 10;
    label = new OmSourceLabel( _group, "Right Ascension", xPos, yPos, 25,  "The Right-Ascension of the selected source" );
    maxWidth = max(maxWidth, label->geometry().right());

    yPos = label->geometry().bottom() + 5;
    label = new OmSourceLabel( _group, "Declination", xPos, yPos, 25,  "The Declination of the selected source" );
    maxWidth = max(maxWidth, label->geometry().right());

    yPos = label->geometry().bottom() + 10;
    label = new OmSourceLabel( _group, "Instrumental mag", xPos, yPos, 25,  
             "The instrumental magnitude of the selected source" );
    maxWidth = max(maxWidth, label->geometry().right());


  

    /******************************************************************
    * A spin box to set the source number
    *****************************************************************/
    yPos = 30;
    xPos = maxWidth + 10;
    _spinBoxNumber = new QSpinBox(_group, "a");
    _spinBoxNumber->setGeometry(xPos, yPos, 60, 25);
    _spinBoxNumber->setWrapping( true );                                 
    maxWidth = max(maxWidth, _spinBoxNumber->geometry().right());


    connect(_spinBoxNumber, SIGNAL(valueChanged(int)), this, SLOT (selectSource(int)));

    connect(_spinBoxNumber, SIGNAL(valueChanged(int)), this, SLOT(  setListBoxItem(int)));
  
    
    QToolTip::add( _spinBoxNumber, "Change the source number to edit");
    _spinBoxNumber->show();
    _spinBoxNumber->setDisabled(TRUE);

 

    /****************************************************
    * X and Y coordinates
    ****************************************************/
  
    yPos = _spinBoxNumber->geometry().bottom() + 20;

 

    _xCoord = new OmSourceEdit( _group, "xcoord", xPos, yPos, 25 );
    _xCoord->setReadOnly( true );
 
    _xCoord->setDisabled(true);
    _xCoord->setAlignment(Qt::AlignVCenter);
    maxWidth = max(maxWidth, _xCoord->geometry().right());


    yPos = _xCoord->geometry().bottom() + 5;

    _yCoord = new OmSourceEdit(_group, "ycoord", xPos, yPos, 25);
    _yCoord->setReadOnly( true );

    _yCoord->setGeometry(xPos, yPos, 60, 25 ); 
    _yCoord->setDisabled(true);
    _yCoord->setAlignment(Qt::AlignVCenter);
    maxWidth = max(maxWidth, _yCoord->geometry().right());

     
    /****************************************************
    * Right Ascension and declination
    ****************************************************/
  
    yPos = _yCoord->geometry().bottom() + 10;

    _ascension = new OmSourceEdit(_group, "12h59m48.100s", xPos, yPos, 25);
    _ascension->setReadOnly( true );
   
 
    _ascension->setDisabled(true);
    _ascension->setAlignment(Qt::AlignVCenter);
    maxWidth = max(maxWidth, _ascension->geometry().right());


    yPos = _ascension->geometry().bottom() + 5;    
 

    _declination = new OmSourceEdit(_group, "-59d28m45.100s", xPos, yPos, 25);
    _declination->setReadOnly( true );
  
    _declination->setDisabled(true);
    _declination->setAlignment(Qt::AlignVCenter);
    maxWidth = max(maxWidth, _declination->geometry().right());


  
    
    /***********************************************************
    * The instrumental magnitude
    **********************************************************/ 

  
  
     yPos = _declination->geometry().bottom() + 10;
 
 

      
    _magnitude = new OmSourceEdit(_group, "19.24", xPos, yPos, 25);
    _magnitude->setReadOnly( true );
   
  
    _magnitude->setDisabled(true);
    _magnitude->setAlignment(Qt::AlignVCenter);
    maxWidth = max(maxWidth, _magnitude->geometry().right());


 
  
    _group->resize( maxWidth + 20, _magnitude->geometry().bottom() + 20);
    _reporter->setProgress(15);
 


    // Exit button
  
    xPos = max(20, rect().width() / 3 - 50);
    yPos = _group->geometry().bottom() + 10;
   
    // Group box for the exit button
    /// Added code 2010-09-28
    {
    OmSourceGroupBox* group = new OmSourceGroupBox( this, "Save source list and exit", 
           20, yPos, 200, 50, "Give the name to the output source list, save it and exit the program");

    QHBoxLayout* layout = new QHBoxLayout(group);
    layout->setMargin(15);
    layout->setSpacing(25);
 
    _exitBtn= new OmSourceButton(group, "&exit", xPos, yPos+10, 70, 25,  
                 "Click here to exit the program, save the source list and any other changes");  
    layout->addWidget(_exitBtn, 1);

    // end added code 
    /*
    _exitBtn= new OmSourceButton(this, "&exit", xPos, yPos, 70, 25,  
                 "Click here to exit the program and save any changes");  
    */  
    connect(_exitBtn, SIGNAL(clicked()), this, SLOT (okay()) );
    }
 
    xPos += 90;
    yPos += 60;

    _cancelBtn= new OmSourceButton(this, "&cancel", xPos, yPos, 70, 25,  
                 "Click here to exit the program without saving any changes");    
  
  
    connect(_cancelBtn, SIGNAL(clicked()), parent, SLOT (Exit()) );
    xPos += 90;
    _restartBtn= new OmSourceButton(this, "&restart", xPos, yPos, 70, 25, 
             "Click here to restart");    
  
    
    connect(_restartBtn, SIGNAL(clicked()), this, SLOT (restart()) );
   
    
    _reporter->setProgress(16);
  

    setGeometry( 0, 0, width(), _cancelBtn->geometry().bottom() + 20);    




 
     // load display
    _display = new OmImageDisplay;
     
    _reporter->setProgress(2);
  
 
    if (!_display->isUp())
        errstr << "Could not launch Imageviewer(ds9)" << Sas::error("NoDisplayer");
    

    _display->displayImage(_imageFileName);
	    
   
    _display->send("zoom to fit");
    

    _display->send("cmap heat"); 
    _display->send("scale zscale");
    _display->send("scale linear");
        
    _display->setNewRegionsColour( _newRegionsColour );






    Initialise();



    _timer = new QTimer( this);

    connect( _timer, SIGNAL(timeout()), this, SLOT(viewAll()) );
 


   
    setFocusPolicy( QWidget::ClickFocus );










    //    ProcessDlg *processDlg = new ProcessDlg(this, ProcessDlg::computeBackgroundImage);
    //    processDlg -> exec();
  


       
}
/*******************************************************
* 
*******************************************************/
void OmSourceBrowser::Initialise()
{ 
 
 
    refreshListBox();
      
 
    _reporter->setProgress(17);
  
 
    DataSet *set = dataSetServer->open(string(_imageFileName), Dal::Read);

    if (set->hasAttribute("TELESCOP"))
        _obsDetails.telescope = (set->attribute("TELESCOP")->asString()).c_str();
 
    if (set->hasAttribute("INSTRUME"))  
        _obsDetails.instrument = (set->attribute("INSTRUME")->asString()).c_str();


    if (set->hasAttribute("OBS_ID"))
        _obsDetails.obsId = (set->attribute("OBS_ID")->asString()).c_str();

    if (set->hasAttribute("EXP_ID"))  
        _obsDetails.expId = (set->attribute("EXP_ID")->asString()).c_str();
 
    if (set->hasAttribute("DATE-OBS"))
       _obsDetails.dateObs = (set->attribute("DATE-OBS")->asString()).c_str();

    if (set->hasAttribute("DATE-END"))
        _obsDetails.dateEnd = (set->attribute("DATE-END")->asString()).c_str();

    if (set->hasAttribute("FILTER"))
        _obsDetails.filter = (set->attribute("FILTER")->asString()).c_str();
    
    if (set->hasAttribute("OBJECT"))
        _obsDetails.object = (set->attribute("OBJECT")->asString()).c_str();
 

    if (set->hasAttribute("OBSERVER"))
        _obsDetails.observer = (set->attribute("OBSERVER")->asString()).c_str();

    if (set->hasAttribute("EXPOSURE"))
        _obsDetails.exposure = (float)set->attribute("EXPOSURE")->asInt();

    if (set->hasAttribute("BINBPE"))
        _imageDetails.binBpe = set->attribute("BINBPE")->asBool();

    if (set->hasAttribute("BINAX1"))
        _imageDetails.binAx1 = set->attribute("BINAX1")->asInt();

    if (set->hasAttribute("BINAX2"))
        _imageDetails.binAx2 = set->attribute("BINAX2")->asInt();
    
    if (set->hasAttribute("FRAMTIME"))
          _imageDetails.frameTime = set->attribute("FRAMTIME")->asReal();

    if (set->hasAttribute("DEADFRAC"))
          _imageDetails.deadFraction = set->attribute("DEADFRACTION")->asReal();
   
    if (set->hasAttribute("DATAMODE"))
          _imageDetails.dataMode = set->attribute("DATAMODE")->asString();
   
  

    
    dataSetServer->close(set);
           
    // Compute the global background
    float error;
    F90MODPROC(omsource_glue, computebackground)(_imageDetails.background, error);
    error = 0.0;

  
    /*********************************************************
    * Compute the start/end/mid-point JDs
    *********************************************************/
  
    F90MODPROC(omsource_glue, computejuliandates)(_obsDetails.JDStart, 
		 _obsDetails.JDEnd, _obsDetails.JDMiddle);
 
    _reporter->setProgress(18);
 
    delete _reporter;
    _reporter = 0;

    _loadImageBtn->setEnabled(true);
    
}
/******************************************************
* destructor
*******************************************************/

OmSourceBrowser::~OmSourceBrowser()
{
    _display->down();
    delete _display;
    delete _timer;
   
    saveFileNames();      
}
/****************************************************
 *
 *
 ***************************************************/
void OmSourceBrowser::close()
{
    // Save the name of the image file in the settings
  // for next run
    addFileToList(_imageFileList, _imageFileName);

    //    cout << "OmSourceBrowser close line 616 _newSourceListFile= " <<  _newSourceListFile << endl;


    if (_sourceListHasChanged)
    {
      if (getNewSrcListFile())
	{
	 

          QString text= "Creating new source-list file (" + QString((const char *)_newSourceListFile) + 
                    ")\n omatt will run\n\n - please wait"; 
          _newSourceFileList += _newSourceListFile;

	  //  cout << "omsourcebrowser.cc line 854\n";

	  ProcessDlg* finishProcessDlg = new ProcessDlg(this, 0, text, 
               ProcessDlg::createNewSourceListFile);    

            int retValue = finishProcessDlg->exec();
	    delete finishProcessDlg;

	    //  cout << "omsourcebrowser.cc line 862 retvalue=" << retValue << endl;

         
           switch (retValue)
           {

	    
               case (FAILED):
    
		 // cout << "Line 871\n";
      
	          return;
      
              default:
		// cout << "Line 876\n";
      

                  return;


           }
	}
    }
    else
    {
      // cout << "Line 887\n";
      
      OmImageRegions::deleteAllRegions();
      // cout << "Line 890\n";
      
      F90MODPROC(omsource_glue, deletelist)();
      // cout << "Line 893\n";
      

    }
}
/********************************************************
 * selectSource
 *******************************************************/
void OmSourceBrowser::selectSource(int no) 
{
    

    _sourceNo = no;
    _photometryBtn->setEnabled(TRUE);
    _deleteSourceBtn->setEnabled(TRUE);
    //   _deconSourceBtn->setEnabled(TRUE);
       

    setSourceCoordinates();
    //    updateDisplay();
   


}; 
/********************************************************
 * setListBoxItem
 *******************************************************/
void OmSourceBrowser::setListBoxItem(int index) 
{
    _sourceNo = index;
    //    _list->setCurrentItem(index - 1); 
    _photometryBtn->setEnabled(TRUE);
    _deleteSourceBtn->setEnabled(TRUE);
    //        _deconSourceBtn->setEnabled(TRUE);
 
};
/*****************************************************
* SetSpinBoxValue
******************************************************/
void OmSourceBrowser::SetSpinBoxValue(int num)   
{ 
    _spinBoxNumber->setValue(num + 1); 

}

/*************************************************************
 * deleteList
 * Purpose - deletes all the sources from the list
 ************************************************************/
void OmSourceBrowser::deleteList()
{
  
    disableButtons();
    QObject::blockSignals( true );
    OmImageRegions::deleteAllRegions( );



    F90MODPROC(omsource_glue, deletelist)();
 

   _loadSourceListBtn->setEnabled(true);
 
  
    refreshListBox();


    viewAll();
 
    QObject::blockSignals( false );
    enableButtons();

}
/******************************************************
* recompute
* This is activated from OmSourceEditor when the apply
* button is clicked.
*******************************************************/
void OmSourceBrowser::recompute(const OmSourceParameter& s)
{
    disableButtons();
    QObject::blockSignals( true );


    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
  
    mySources[_sourceNo] = s;
 

    F90MODPROC(omsource_glue, recompute)(_sourceNo);
    
    /*********************************************************************
    * Replace the source in the list box with the computed source values
    *********************************************************************/

    refreshListBox();
    _display->zoomTo(s);
 

    _changed = TRUE;

    // ************************************************NB 
    //    edit(_current - 1);
    SetSpinBoxValue(_sourceNo - 1);    


 
    QObject::blockSignals( false );

    enableButtons();

}
/******************************************************
* deleteSource
*******************************************************/
void OmSourceBrowser::deleteSource()
{

    disableButtons();
    QObject::blockSignals( true );


  // update the scrollview AND mySources!
     _sourceListHasChanged = true;
  
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
    if (!_sourceNo || mySources.length() < _sourceNo) return;

   

    // Delete the source region
    OmImageRegions::deleteRegion( _sourceNo, _display);


    F90MODVAR(omsource_glue, remove)(_sourceNo);
    
 
    refreshListBox();
    viewAll();    
   
    QObject::blockSignals( false );
    enableButtons();

}
/******************************************************
* disableButtons
*******************************************************/
void OmSourceBrowser::disableButtons()
{


    _sourceTableBtn->setDisabled( true );
    _deleteListBtn->setDisabled( true );
    _detectSourcesBtn->setDisabled( true );
    _photometryBtn->setDisabled( true );
    _deleteSourceBtn->setDisabled( true );
    _spinBoxNumber->setDisabled( true );
    _viewAllBtn ->setDisabled( true );
    _viewSourceBtn->setDisabled( true );
    _addSourcesBtn->setDisabled( true );
    _loadImageBtn->setDisabled( true );
    _loadSourceListBtn->setDisabled( true );
   
    _informationBtn->setDisabled( true );
    _exitBtn->setDisabled( true );
    _cancelBtn->setDisabled( true );
    _restartBtn->setDisabled( true );
   






     qApp->processEvents();

}

/******************************************************
* disableButtons
*******************************************************/
void OmSourceBrowser::enableButtons()
{

 
    _sourceTableBtn->setEnabled( true );
    _deleteListBtn->setEnabled( true );
    _detectSourcesBtn->setEnabled( true );
    _photometryBtn->setEnabled( true );
    _deleteSourceBtn->setEnabled( true );
    _spinBoxNumber->setEnabled( true );
    _viewAllBtn ->setEnabled( true );
    _viewSourceBtn->setEnabled( true );
    _addSourcesBtn->setEnabled( true );
    _loadImageBtn->setEnabled( true );
    _loadSourceListBtn->setEnabled( true );
   
    _informationBtn->setEnabled( true );
    _exitBtn->setEnabled( true );
    _cancelBtn->setEnabled( true );
    _restartBtn->setEnabled( true );
   


  
    qApp->processEvents();

}


/***********************************************************
* viewAll
************************************************************/
void OmSourceBrowser::viewAll()
{

  _timer->stop();
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
        _display->send("zoom to fit");


   _display->send("cmap heat"); 
   _display->send("scale zscale");
   _display->send("scale linear");
        


    //       _display->send("zoom to fit frame");
      
 
    _display->toRegion(mySources, _oldRegionsColour.c_str());
 

}
/********************************************************
* addSources
* Displays teh dialogue to allow the user
* to add sources to the list
*******************************************************/
void OmSourceBrowser::addSources()
{

    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
 
    if (mySources.ubound() > 0)
        SetSpinBoxValue(mySources.ubound());
 
   
     viewAll();
     /*****************************************************************************
     * Get the photometry aperture radius
     ***************************************************************************/
    PhotometryParameters photParameters = F90MODVAR(omsource_glue, myphotometryparameters);
    
    


    /*********************************************************************
     * Show the dialogue window for selectin new sources
     ********************************************************************/
    hide();
   qApp->processEvents();
 
   

    AddSourcesDlg *addSourcesDlg = new AddSourcesDlg(this, _display, photParameters.apertureRadius);

   
    addSourcesDlg->move(0, 0);
    

    int retValue = addSourcesDlg->exec();






    delete addSourcesDlg;





    show();
   qApp->processEvents();
 
    _spinBoxColour1->setValue( _oldRegionsNo );

  
    switch (retValue)
    {    

        case (QDialog::Accepted):
 

          break;  
	  //	  return;
    case (QDialog::Rejected):
      for (int i = 0; i < 10; i++)
	QApplication::beep();
    
        refreshListBox();

	    return;  
        default:
          break;
    };


 

    _sourceListHasChanged = true; // Record that the source-list has changed
    
 
    // Get the user selected points from the image
    OmSourceRegions *points = OmImageRegions::GetRegions(_display); 
    
 
 
    if (!points->ubound())
    {
     
        QString text= QString("Please select sources manually (click Add sources button)") +
                      QString(" or click Run omdetect button to detect sources");
    
 
	    emit SetStatusBarMessage(text);
      
        return;
    }
    else 
    {
      
        QString text= omsourceVersionNo();
       
        emit SetStatusBarMessage(text);
       

    }  

 
    // ... pass it to fortran to compute their properties ...   

   

    //    F90MODPROC(omsource_glue, addregions)(points);
  
    delete points;  // Need to delete them  


    // refresh
    refreshListBox();
 
}
/******************************************************************
* refreshListBox
* - loads the list box that displays the parameters for each source
*****************************************************************/
void OmSourceBrowser::refreshListBox()
{
   
    // Load the sources
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources); 



    //    cout << "refrshlistbox line 1007 calling toregion\n";

    _display->toRegion(mySources, _oldRegionsColour.c_str());
  
  

    if (mySources.ubound() > 0)
    {
   
   
        _sourceTableBtn->setEnabled(TRUE);
	_deleteListBtn->setEnabled(TRUE);
    
     
	
        _detectSourcesBtn->setDisabled(TRUE);
        _photometryBtn->setEnabled(TRUE);
        _deleteSourceBtn->setEnabled(TRUE);


	//	_deconSourceBtn->setEnabled(TRUE);
 
	

        _spinBoxNumber->setEnabled(TRUE);
  
    
        _spinBoxNumber->setMinValue(1);
      

	_spinBoxNumber->setMaxValue(mySources.ubound());
        _spinBoxNumber->setValue(1);
        
        _group->setEnabled(TRUE);
        _viewAllBtn ->setEnabled(TRUE);
        _xCoord->setEnabled(true);
        _yCoord->setEnabled(true);
        _ascension->setEnabled(true);
        _declination->setEnabled(true);
        _magnitude->setEnabled(true);

        _viewSourceBtn->setEnabled(TRUE);
   
  

        QString string = omsourceVersionNo();
       
        emit SetStatusBarMessage(string);
        
	string.sprintf("Source Browser (No of sources=%d)", mySources.ubound());

        SetCaption(string);

        string.sprintf("Source selection (No of sources=%d)", mySources.ubound());

        
	_group->setTitle(string); 


 
    }	
    else
    {

	   
   
        _spinBoxNumber->setDisabled(TRUE);
 
    
	_deleteListBtn->setDisabled(TRUE);
        _sourceTableBtn->setDisabled(TRUE);
  
	
        _detectSourcesBtn->setEnabled(TRUE);
        _photometryBtn->setDisabled(TRUE);
	//	_deconSourceBtn->setDisabled(TRUE);
 
        _group->setDisabled(TRUE);
       _viewAllBtn ->setDisabled(TRUE);
       _deleteSourceBtn->setDisabled(TRUE);

        _xCoord->setDisabled(true);
        _yCoord->setDisabled(true);
        _ascension->setDisabled(true);
        _declination->setDisabled(true);
        _magnitude->setDisabled(true);
  
        _viewSourceBtn->setDisabled(TRUE);
 
        QString text =  
            "Please select sources manually (click on Add sources button) or click Run omdetect button to detect sources";
    
 
        emit SetStatusBarMessage(text);
   

        SetCaption("Source Browser (No of sources=0)");
      

    }  
  

}
/******************************************************
* print
******************************************************/
void OmSourceBrowser::print()
{
#ifndef QT_NO_PRINTER

    QPrinter printer; 
    if ( printer.setup(this) ) {                // opens printer dialog
        printer.setFullPage(TRUE);              // we'll set our own margins
	QPainter p;
	p.begin( &printer );                    // paint on printer
	p.setFont( p.font() );
	QFontMetrics fm = p.fontMetrics();
	QPaintDeviceMetrics metrics( &printer ); // need width/height
                                                 // of printer surface
    
        /*********************************************
	* Print what ever
	********************************************/
        (this->*Print)(&printer, &p,  &fm,  &metrics);

	p.end();                                // send job to printer
    }
#endif
}


/*****************************************************************************
*
* printHeading
****************************************************************************/
void OmSourceBrowser::printHeading(QPainter* p,  
                                  QFontMetrics* fm,  
                                  QPaintDeviceMetrics* metrics,
                                  const int MARGIN, int &yPos)
{
    QDateTime date = QDateTime::currentDateTime();  // The current date and time
    
    QString text = QString("Listing produced by ") + omsourceVersionNo()+ QString("  ") + date.toString();  
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += 2 * fm->lineSpacing();
   
    text = QString("TELESCOPE=") + _obsDetails.telescope + QString(" INSTRUMENT=") + _obsDetails.instrument;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text = QString("OBS_ID=") + _obsDetails.obsId + QString(" EXP_ID=") + _obsDetails.expId;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text = QString("DATE-OBS=") + _obsDetails.dateObs + QString(" DATE-END=") + _obsDetails.dateEnd;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text = QString("OBJECT=") + _obsDetails.object + QString(" OBSERVER=") + _obsDetails.observer;
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += fm->lineSpacing();

    text.sprintf("FILTER=%s EXPOSURE=%d (SECONDS)", (const char *)_obsDetails.filter, 
           (int)_obsDetails.exposure);
    p->drawText( MARGIN, yPos, metrics->width() - 2 * MARGIN,
                     fm->lineSpacing(), ExpandTabs, text);
    yPos += 5 * fm->lineSpacing();

}

/************************************************************
* detectSources
* purpose:  Runs the source detection program, omdetect,
*           on the input image tro 
*************************************************************/
void OmSourceBrowser::detectSources() 
{
   
    char tempFile[256];

    TempFile::createTempFile(tempFile);
     
   

    // Display the dialogue to run omdetect
    DetectionDlg *detectionDlg = new DetectionDlg(this, QString(_imageFileName), QString(tempFile));

 



    int retValue = detectionDlg->exec();
    delete detectionDlg;
    

    switch (retValue)
    {
        case (FAILED):
          remove(tempFile);
    
	  return;
      
        default:
          break;
    };



    //    ExceptionErrorHandler local;
    //    ErrorHandler* oldHandler = errHandler.handler(&local);
    //    const bool invoke = true;
    
    //    Info::Task *t;
    //    t = task("ommag");
    //    t->setParameter("set", tempFile);
  
 

    string command = "ommag set=" + string(tempFile);
    system(command.c_str());
  
 
 


    //    try {
	
    //        t->exec(invoke);
    //    }
    //   catch (SasException::Error e) {
    //	QString message(e.message.c_str());
    //	message += "\nReturn to main window or exit program?";

    //	switch( QMessageBox::warning(this, t->name(), message, "main window", "exit", QString::null, 0, 1)) 
    //   {
    //	    case 0: // Try again or Enter
    //          errHandler.handler(oldHandler);
	
    //	      return;
	    // try again
	 
    //	    case 1: // Quit or Escape
	    // exit
    //	        errHandler.handler(oldHandler);
    //	        Exit();
    //	}
      
    //   }
    //  errHandler.handler(oldHandler); // return to default error handler

 
 
    // Load the sources
   
 
    string file = stringParameter("wdxset");
    setParameter("wdxset", tempFile );
    F90MODPROC(omsource_glue, loadsources)();
    setParameter("wdxset", file );


 

   remove(tempFile);
   //          cout << "Line 1200\n";

   //    t = task("omsource");
  
    QApplication::beep();        
         
    //  cout << "Line 1474\n";
 


    refreshListBox();


    // cout << "Line 1481\n";
 

    viewAll();
  
    // cout << "Line 1486\n";
 

    if( _spinBoxNumber->isEnabled())
        _sourceListHasChanged = true;
 
    // cout << "Line 1492\n";
 

}

/************************************************************
*
* photometry
* purpose: Displays a dialogue to allow the photometry 
*          of the selected source to be re-computed
*  
*************************************************************/
void OmSourceBrowser::photometry() 
{
   
     
    // Display the dialogue to run the photometry dialog
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);

    
  
  
    //   cout << "omsourceb line 255 inner radius=" << mySources[1].innerbackgroundradius << endl;
    // cout << "omsourceb line 255 outer radius=" << mySources[1].outerbackgroundradius << endl;


    if (mySources.length() < 1) return;

    int retValue = 0;
    if(_imageDetails.dataMode == "IMAGING" || _imageDetails.dataMode == "MOSAICED" )
    {
        // Create the photometry dialogue  
        PhotometryDlg *photometryDlg = new PhotometryDlg(_sourceNo,  
          _display, &_obsDetails, &_imageDetails, _oldRegionsColour, _colourList, this);
   
     
        retValue = photometryDlg->exec();
        delete  photometryDlg;
    }
    else if(_imageDetails.dataMode == "FAST")
    {
        // Create the photometry dialogue for FAST mode data 
        FastPhotometryDlg *photometryDlg = new FastPhotometryDlg(_sourceNo,  
          _display, &_obsDetails, &_imageDetails, _oldRegionsColour, _colourList, this);
   
  
   
        retValue = photometryDlg->exec();
        delete  photometryDlg;

    }
    else // Unknown MODE
    {
 
        QMessageBox::critical( 0, "omsource",
			       QString("Unknown data mode-"));



    }

 
    ShowParent();
    switch (retValue)
    {
        case (QDialog::Accepted):
          _sourceListHasChanged = true; // Record that the source-list has been modified

	  //         refreshListBox();
          setSourceCoordinates();


        case (QDialog::Rejected):

	   

        default:
          break;
    };
    viewAll();
}

/******************************************************
* getImageFile
* Purpose:- Gets the name of the input and output file names
* given as parameters
*******************************************************/

void OmSourceBrowser::getImageFile()
{
    bool hasFrameTime;

    QString filterList[4];
    
 
    filterList[0]  = "Images (*)";
    filterList[1]  = "Images (*.FIT *.fit)";
 
    filterList[2]  = "Images (*IMAGE_* *image_*)";
 
    filterList[3] = QString::null;

    while(1)
    {
    
      
        GetOldFileName(this, _imageFileName, "imageset", 
      		     "Please select the image fits file (P0*OMS*IMAGE_*FIT*)", filterList);
      


   
        DataSet *set = dataSetServer->open(string(_imageFileName), Dal::Read);
	if (set->hasAttribute("FRAMTIME"))
	    hasFrameTime = true;
	else
	    hasFrameTime = false;
         
    
        if(set->hasBlock("MODES")) 
        {
   
            dataSetServer->close(set);
 
            break;
        } 
  
 
	else{
	  dataSetServer->close(set);
  
      
	  //QMessageBox::critical( 0, "omsource",
	  QMessageBox::warning( 0, "omsource",
			       QString("The selected image does not contain a `MODES' block\n")+
			       QString("(it might be processed incorrectly).\n")  +
                               QString("The image file should be the product\n") + 
                               QString("created by ommodmap.\n\n\n")        +
                               QString("Continue ... ")); 
	  
	  break;
	}

    }  // End of while(1)
      
    setParameter("imageset", string(_imageFileName));
  

    
    if (!hasFrameTime)  // Old image file without FRAMETIME & DEADFRAC
    {
        if (stringParameter("wdxset") == "")
  	{

            QString filterList[4];
            filterList[0]  = "(*WDX*)";
            filterList[1]  = "(*wdx*)";
             
            filterList[2]  = "(*.FIT *.fit)";
            filterList[3] = QString::null;
  
            GetOldFileName(this, _wdxFileName, "wdxset", 
  		     "A window data file is needed-\n"
                     "Please select the *OM*WDX*FIT* file", filterList);
  


             setParameter("wdxset", string(_wdxFileName));

             
         }
    }
 

    
}  
/******************************************************
* getImageFile
* Purpose:- Gets the name of the input and output file names
* given as parameters
*******************************************************/

void OmSourceBrowser::getOldSrcListFile()
{


    QString filterList[4];
    filterList[0]  =  "(*)";
    
    filterList[1]  =  "(*.FIT *.fit)";
    filterList[2]  =  "SWS Files (*SWS* *sws*)";

    filterList[3] = QString::null;

  
    
    while(1) {



       GetOldFileName(this, _oldSourceListFile, "oldsrclistset", 
		       "Please select the source-list file (*P0/IO**SWS*FIT*)", filterList);

    
    
        DataSet *set = dataSetServer->open(string(_oldSourceListFile), Dal::Read);

	if (set->hasBlock("SRCLIST"))
	{

	    // Check that the observation IDs are identical
            string obsId = (set->attribute("OBS_ID")->asString()).c_str();
            dataSetServer->close(set);
	    
	    if (_obsDetails.obsId == QString((const char *)obsId.c_str()))

	        break;
            else
	      {
		QApplication::beep();
                QMessageBox::critical( this, omsourceVersionNo(),
				       QString("The observationID (") + QString(obsId.c_str()) +
                                       QString("\nin the selected file is not the same (") + 
                                       _obsDetails.obsId +
                                       QString (")\nas that in the image file\n\n\n") + 
                                       QString("Please try again")); 


              }




        }
        else
	{
        QMessageBox::critical( this, omsourceVersionNo(),
			       QString("The selected source-list file cannot be processed\n") +
			       QString("It does not contain a 'SRCLIST' table\n") +
                               QString("The source-list file should either be a product\n") +
                               QString("source-list file created by omatt\n") +
                               QString("or one that has been created by omsource\n\n\n") + 
                QString("Please try again")); 

	//l( "<font color=darkblue><u><b>"
	//          "Information menu</b></u></font>", this );

        dataSetServer->close(set);
        }
    }               
    setParameter("oldsrclistset", string(_oldSourceListFile));
}  
/****************************************************************
 *
 ***************************************************************/
bool OmSourceBrowser::getNewSrcListFile()
{
  //  cout << "getNewSrcListFile line 1361\n";
    string fileName = stringParameter("newsrclistset");
    strcpy(_newSourceListFile, fileName.c_str());
    
    //    cout << "getNewSrcListFile line 1365 _oldSourceListFile=" << _newSourceListFile << endl;

    bool result = GetNewFileName(this, _newSourceListFile, 
          "newsrclistset", "Please enter the file-name for the new source-list",
		   (const char *)omsourceVersionNo());
 
    if (!result) return false;
    setParameter("newsrclistset", string(_newSourceListFile));
 
    return true;
}

/***********************************************
* setSourceCoordinates
***********************************************/
void OmSourceBrowser::setSourceCoordinates()
{
 
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
    OmSourceParameter* currentSource = &mySources[_sourceNo];

 
    QString text;
    _xCoord->setText(text.sprintf("%9.1f",  currentSource->xcoord));

    _yCoord->setText(text.sprintf("%9.1f",  currentSource->ycoord));
  
    AngleFormatter af;
    af.setMode(AngleFormatter::HMS);
    _ascension->setText(af.asString(currentSource->rightascension).c_str());



    af.setMode(AngleFormatter::DMS);
    _declination->setText(af.asString(currentSource->declination).c_str());
    _magnitude->setText(text.sprintf("%5.2f+/-%3.2f",  currentSource->magnitude, currentSource->magnitudeerror) );
  

   
}
/************************************************
* updareDisplay
************************************************/
void OmSourceBrowser::updateDisplay()
{
       
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
    OmSourceParameter* currentSource = &mySources[_sourceNo];
  
    _display->toRegion(mySources, _oldRegionsColour.c_str());
 
    _display->zoomTo(*currentSource);   
 
}
/************************************************
* diaplaySource
************************************************/
void OmSourceBrowser::displaySource()
{
       
    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
    OmSourceParameter* currentSource = &mySources[_sourceNo];
  

    _display->toRegion(mySources, _oldRegionsColour.c_str());
 
    _display->displaySource(_sourceNo, *currentSource);   
 
 

}
/**************************************************
* 
**************************************************/
void OmSourceBrowser::deconvolveSource()
{


  //    OmSourceParameters& mySources = F90MODVAR(omsource_glue, mysources);
 

  //    int maxNoSources = 10; 
  //    OmSourceParameter *sources = new OmSourceParameter[maxNoSources];
  //    for (int i = 0; i < maxNoSources; i++)
  //     { 
  //      sources[i] = mySources[_sourceNo];
  //      cout << i << ") Line 1580 x=" << sources[i].xcoord << endl;
  //      }
  //    DeconvolveDlg *deconvolveDlg = new DeconvolveDlg(this, _sourceNo, sources, _display, _imageFileName  );
  

  //    int retValue = deconvolveDlg->exec();
  //   delete  deconvolveDlg;
  //    delete [] sources;
  //    switch (retValue)
  //    {
  //    case (QMessageBox::Yes):
    
  //       return;
  //    case (QMessageBox::No):

  //    default:
  //        break;
  //    };

}
/*******************************************************
*
******************************************************/
void OmSourceBrowser::displayInformation()
{

    QPopupMenu *informationMenu  = new QPopupMenu( this );
    
    InformationMenu(this, informationMenu);
  
		
    informationMenu->exec(QCursor::pos());

    delete informationMenu;
   
}
/*************************************************
 *
 ************************************************/
void OmSourceBrowser::displayObservationDetails(const OmSourceBrowser::ObsDetails 
                   *obsDetails)
{
    QString text[12];
    text[0] = QString("Telescope=") + obsDetails->telescope;
    text[1] = QString("Instrument=") + obsDetails->instrument;
    text[2] = QString("obsId=") + obsDetails->obsId;
    text[3] = QString("expId=") + obsDetails->expId;
    text[4].sprintf("dateObs=%s (JD=%10.4f)", (const char *)obsDetails->dateObs, 
                      obsDetails->JDStart);
    text[5].sprintf("dateEnd=%s (JD=%10.4f)", (const char *)obsDetails->dateEnd, 
                      obsDetails->JDEnd);
    text[6].sprintf("Julian date of observation mid-point=%10.4f", 
                obsDetails->JDMiddle);
 
    text[7] = QString("Filter=") + obsDetails->filter;
    text[8] = QString("Object=") + obsDetails->object;
    text[9] = QString("Observer=") + obsDetails->observer;
    text[10].sprintf("Exposure=%d %s", int(obsDetails->exposure), " seconds");
  
    text[11] = QString::null;  
   
    InformationDlg *informationDlg = new InformationDlg(0, text);
  
    informationDlg->exec();
    delete  informationDlg;

}

/**********************************************************************************
 *
 ********************************************************************************/
void OmSourceBrowser::aboutQt() 
{ 
  QMessageBox::aboutQt ( this); 


}; 




/*************************************************
 *
 ************************************************/
void OmSourceBrowser::showObservationDetails()
{
    displayObservationDetails(&_obsDetails);

}

/*************************************************
*
************************************************/
void OmSourceBrowser::showImageDetails()
{
    displayImageDetails(&_imageDetails);

}
/*************************************************
 *
 ************************************************/
void OmSourceBrowser::displayImageDetails(const OmSourceBrowser::ImageDetails *imageDetails)
{
    QString text[7];

 
    if (imageDetails->binBpe)
        text[0] = "BinBpe=true";

    else
        text[0] = "BinBpe=false";


    text[1].sprintf("Binax1=%d", imageDetails->binAx1);
    text[2].sprintf("Binax2=%d", imageDetails->binAx2);
    text[3].sprintf("Frame time=%.1f milliseconds", imageDetails->frameTime);
    text[4].sprintf("Dead fraction=%f", imageDetails->deadFraction);
    text[5].sprintf("Image background==%f", imageDetails->background);


    text[6] = QString::null;  
   
    InformationDlg *informationDlg = new InformationDlg(0, text);
  
    informationDlg->exec();
    delete  informationDlg;

}

/*************************************************
 *
 ************************************************/
void OmSourceBrowser::okay()
{

  //  cout << "omsourceBrowser line 2032 okay calling close\n";
    close();

    // cout << "omsourceBrowser line 2035 okay\n";

    Exit();       

    // cout << "omsourceBrowser line 2039 okay\n";



}


/*************************************************
 *
 ************************************************/
void OmSourceBrowser::restart()
{
    close();
    deleteList();
    F90MODPROC(omsource_glue, init)(_sourceListIsLoaded);
    _loadSourceListBtn->setEnabled(!_sourceListIsLoaded);
 
}
/*************************************************
 *
 ************************************************/
void OmSourceBrowser::loadImage()
{
    
    close();
  
    // Get the name of the image file name
   
    addFileToList(_imageFileList, _imageFileName);
 
    if (_sourceListIsLoaded)
    {
      
      QString message("A source-list has been loaded- this will be deleted");
        switch( QMessageBox::warning(this, omsourceVersionNo(), message, "OK", "Cancel", QString::null, 0, 1)) 
        {
	    case 0: // Try again or Enter
              
	
	      break;
	    // try again
	 
	    case 1: // Quit or Escape
	    
	      return;
	}
      
    }

    deleteList();
    _sourceListIsLoaded = false;


    setParameter("imageset", "");
    setParameter("oldsrclistset", "");
    _loadImageBtn->setDisabled(true);
 
    getImageFile();
    hide();
    _reporter = new OmProgressDialog("Initialising", 18);
    
    _reporter->setProgress(1);




    if (!_display->isUp())
    {
        delete _display;
  
       _display = new OmImageDisplay;
    }  

    
    _display->displayImage(_imageFileName);
    _display->send("zoom to fit frame");

    _display->send("cmap heat"); 
   _display->send("scale zscale");
   _display->send("scale linear");
        




   
      
    F90MODPROC(omsource_glue, init)(_sourceListIsLoaded);
    _loadSourceListBtn->setEnabled(!_sourceListIsLoaded);
 
    show();
  
  
    Initialise();
   
 
}
/*************************************************
 *
 ************************************************/
void OmSourceBrowser::loadSourceList()
{
    close();
    deleteList();


 // Get the name of the image file name
    setParameter("oldsrclistset", "");

    displayOldSourceListFileMenu();

    addFileToList(_oldSourceFileList, _oldSourceListFile);
     
    
    _reporter = new OmProgressDialog("Initialising", 18);
    
    _reporter->setProgress(1);
  
 

    F90MODPROC(omsource_glue, init)(_sourceListIsLoaded);
    Initialise();
   _loadSourceListBtn->setEnabled(!_sourceListIsLoaded);
 
}
/*************************************************************
*
************************************************************/
//void OmSourceBrowser::mousePressEvent( QMouseEvent* event)
//{
//    QApplication::beep();
//    if ( event->button() == RightButton )
//    {   

//        QPopupMenu *informationMenu  = new QPopupMenu( this );
    
//        InformationMenu(this, informationMenu);



//        informationMenu->exec(QCursor::pos() );

//        delete informationMenu;
//    }
  



//}   
/******************************************************
*
******************************************************/
    
//void OmSourceBrowser::showHelpInformation()
//{

   
//  static const char* sayings[] = {
 
//    "<b>Saying 1:</b><br>"
//    "<hr><br><br>"
//    "<big>Evil is that which one believes of others.  It is a sin to believe evil "
//    "of others, but it is seldom a mistake.</big><br><br>"
//    "<center><i>-- H.L. Mencken</i></center>",

//    "<b>Saying 2:</b><br>"
//    "<hr><br><br>"
//    "<big>A well-used door needs no oil on its hinges.<br>"
//    "A swift-flowing steam does not grow stagnant.<br>"
//    "Neither sound nor thoughts can travel through a vacuum.<br>"
//    "Software rots if not used.<br><br>"
//    "These are great mysteries.</big><br><br>"
//    "<center><i>-- Geoffrey James, \"The Tao of Programming\"</i></center>",

//    "<b>Saying 3:</b><br>"
//    "<hr><br><br>"
//    "<big>Show business is just like high school, except you get paid.</big><br><br>"
//    "<center><i>-- Martin Mull</i></center>",

//    "<b>Saying 4:</b><br>"
//    "<hr><br><br>"
//    "<big><b>The Least Successful Executions</b><br>"
//    "<twocolumn><p>      History has furnished us with two executioners worthy of attention. "
//    "The first performed in Sydney in Australia.  In 1803 three attempts were "
//    "made to hang a Mr. Joseph Samuels.  On the first two of these the rope "
//    "snapped, while on the third Mr. Samuels just hung there peacefully until he "
//    "and everyone else got bored.  Since he had proved unsusceptible to capital "
//    "punishment, he was reprieved.</p>"
//    "<p>        The most important British executioner was Mr. James Berry who "
//    "tried three times in 1885 to hang Mr. John Lee at Exeter Jail, but on each "
//    "occasion failed to get the trap door open.<!p>"
//    "<p>        In recognition of this achievement, the Home Secretary commuted "
//    "Lee's sentence to \"life\" imprisonment.  He was released in 1917, emigrated "
//    "to America and lived until 1933.</p></twocolumn></big><br><br>"
//    "<center><i>-- Stephen Pile, \"The Book of Heroic Failures\"</i></center>",

//    "<b>Saying 5:</b><br>"
//    "<hr><br><br>"
//    "<big>If you can, help others.  If you can't, at least don't hurt others.</big><br><br>"
//    "<center><i>-- the Dalai Lama</i></center>",

//    "<b>Saying 6:</b><br>"
//    "<hr><br><br>"
//    "<big>Television has brought back murder into the home -- where it belongs.</big><br><br>"
//    "<center><i>-- Alfred Hitchcock</i></center>",

//    "<b>Saying 7:</b><br>"
//    "<hr><br><br>"
//    "<big>I don't know who my grandfather was; I am much more concerned to know "
//    "what his grandson will be.</big><br><br>"
//    "<center><i>-- Abraham Lincoln</i></center>",

//    0
//};

//    HelpDlg *helpDlg = new HelpDlg(this, sayings);    

//    helpDlg->exec();
    
     
//    delete helpDlg;  
 
//}


/**********************************************************************
*
**********************************************************************/
void OmSourceBrowser::addFileToList(QStringList &fileList, char file[])
{  
  
 
    if (fileList.findIndex(file) != -1) return; 
  
    if (  fileList.size() > 8)  fileList.pop_front();
    //    QFileInfo fi(file);
    //    QDateTime date = fi.created(); 
   

    fileList += (QString(file)); // + " creation date=" + date.toString());
 
}

/**********************************************************************
*
**********************************************************************/
void OmSourceBrowser::saveFileNames()
{
    QSettings settings;
  
    settings.writeEntry("/OmSource/Images",  _imageFileList, QChar('\t'));
    settings.writeEntry("/OmSource/OldSourceList",  _oldSourceFileList, QChar('\t')); 
    settings.writeEntry("/OmSource/NewSourceList",  _newSourceFileList, QChar('\t'));
  
}
/**********************************************************************
*
**********************************************************************/
void OmSourceBrowser::readFileNames()
{
  
    QSettings settings;
   
    loadUsedFileNames(_imageFileList, "/OmSource/Images"); 
    loadUsedFileNames(_oldSourceFileList, "/OmSource/OldSourceList"); 
    loadUsedFileNames(_newSourceFileList, "/OmSource/NewSourceList");
 
    saveFileNames(); 
   
} 
/**********************************************************************
*
**********************************************************************/
void OmSourceBrowser::loadUsedFileNames(QStringList &list, const char *name)
{
  

    // Get the list from the system file
    QSettings settings;
    list = settings.readListEntry(name , QChar('\t'));
   
    if (list.size() == 0) return;

    QFile file; 
    QStringList temp;
    //    Check that the file still exists
    for ( QStringList::Iterator it = list.begin(); it != list.end(); ++it )

    {
	
        if (file.exists(*it))
            temp += (*it); 
	 

    }   
    list = temp;
} 
/*******************************************************
*
******************************************************/
void OmSourceBrowser::showHistory()
{

  //    HistoryDlg* historyDlg = new HistoryDlg(this, &_imageFileList,  
  //               &_oldSourceFileList, &_newSourceFileList);    

  //    historyDlg->exec();
         
  //    delete historyDlg;  
   
}
/*******************************************************
*
******************************************************/
void OmSourceBrowser::showSourceTable()
{
    // Load the sources 
 
  
    TableDlg* tableDlg = new TableDlg(this);    
    connect(tableDlg, SIGNAL(selectionChanged(int)), this, SLOT(  SetSpinBoxValue(int)));

    connect(tableDlg, SIGNAL(deleteSourceList()), this, SLOT (deleteList()) );
  

    tableDlg->exec();
         
    delete tableDlg;  
   
}
/*****************************************************
*
****************************************************/
void OmSourceBrowser::loadImage1(int id)
{        

    strcpy(_imageFileName,  (const char *)_imageFileList[id - 1]);
    setParameter("imageset", string(_imageFileName));
  
    getImageFile();
}
/********************************************
 *
 ********************************************/
void OmSourceBrowser::displayImageFileMenu()
{
  

    QApplication::beep();

    if (_imageFileList.size() == 0)
    {
        // Just display the file input widget      
        getImageFile();
        return;
    }

  
    // Crate a pop-up menu
    
    QPopupMenu *imageMenu  = new QPopupMenu( this, "imagemenu");
 
 
    QLabel *caption = new QLabel( "<font color=darkblue><u><b>"
              "Please select your image file (*IMAGE_*)</b></u></font>", this);
    caption->setAlignment( Qt::AlignCenter );
    imageMenu->insertItem( caption );
  
 
    int id = imageMenu->insertItem( "&Image file from current directory",  this, 
   				    SLOT( getImageFile()));//, Qt::CTRL+Qt::Key_I );
    
    const char * imageText = "Click this button to open an <em>image file</em>. <br><br>";
    imageMenu->setWhatsThis(id, imageText);

    
    imageMenu->insertSeparator();
     	           
    // Add the image files to the menu 
    int index = 1;
    for ( QStringList::Iterator it = _imageFileList.begin(); it != _imageFileList.end(); ++it ) {
      //        imageMenu->insertSeparator();
   
        QString text;
        text.sprintf("&%d%s", index, (const char *)*it);
	
	id = imageMenu->insertItem(text,  this, SLOT (loadImage1(int)), index, index); 
	index++;

    }                  
    imageMenu->exec(QPoint(300, 300));

    delete imageMenu;
}
/************************************************************
*
***********************************************************/
void OmSourceBrowser::displayOldSourceListFileMenu()
{

    QApplication::beep();

    if (_oldSourceFileList.size() == 0)
    {
        // Just display the file input widget      
        getOldSrcListFile();
        return;
    }

  
    // Crate a pop-up menu
    
    QPopupMenu *sourceListMenu  = new QPopupMenu( this, "imagemenu");
 
 
    QLabel *caption = new QLabel( "<font color=darkblue><u><b>"
              "Please select your source-list file (*SWS*)</b></u></font>", this);
    caption->setAlignment( Qt::AlignCenter );
    sourceListMenu->insertItem( caption );
  
 
    int id = sourceListMenu->insertItem( "&Source-list file from current directory",  this, 
   				    SLOT( getOldSrcListFile()));//, Qt::CTRL+Qt::Key_I );
    
    const char * sourceListText = "Click this button to open a <em>source-list file</em>. <br><br>";
    sourceListMenu->setWhatsThis(id, sourceListText);

    
    sourceListMenu->insertSeparator();
     	           
    // Add the image files to the menu 
    int index = 1;
    for ( QStringList::Iterator it = _oldSourceFileList.begin(); it != _oldSourceFileList.end(); ++it ) {
      //        imageMenu->insertSeparator();
   

        QString text;
        text.sprintf("&%d%s", index, (const char *)*it);
	

  	
	id = sourceListMenu->insertItem(text,  this, SLOT (loadSourceList1(int)), index, index); 
	index++;

    }                   
        
   
    sourceListMenu->exec(QPoint(300, 300));

    delete sourceListMenu;
   

}

/*****************************************************
*
****************************************************/
void OmSourceBrowser::loadSourceList1(int id)
{        
  
    strcpy(_oldSourceListFile,  (const char *)_oldSourceFileList[id - 1]);
    setParameter("oldsrclistset", string(_oldSourceListFile));
   
}

/****************************************************************************
*
*
****************************************************************************/
void OmSourceBrowser::oldRegionColourChanged( int no )
{

    _timer->stop();

    _oldRegionsColour = _colourList[no - 1];
    _oldRegionsNo = no;
   
  

    _timer->start( 2000 ); 
   
         
 
 
}


/****************************************************************************
*
*
****************************************************************************/
void OmSourceBrowser::textChanged()
{


  //  cout << "spin box changed\n";



  QString text = _spinBoxNumber->text();
  //  cout << "text=" << text << endl;

}
      /******************************************************
*
******************************************************/
    
void OmSourceBrowser::showHelpInformation()
{
 

    static const char* information[] = {
  
    "<b>OMSOURCE ALLOWS YOU TO DO THE FOLLOWING</b><br>"
    "<hr><br><br>"
    "<b>1) Manually select sources from an image - </b><br>"
        "Press the \"<b>select Sources</b>\" button which will cause the another window to be displayed<br><br>"
    "<b>2) Select sources from an image by running <b>omdetect</b>- </b><br>"
        "Press the \"<b>omdetect</b>\" button which will the \"omdetect\" window to be displayed."
        "<b> Please note that you will only be able to do this if the current source-list is empty-</b>"
        " If necessary, press the \"<b>delete</b>\" button to delete the current source sourle-list. <br><br>"

    "<b>3) Delete a source - </b><br>"
        "First \"select\" the required source by using the \"<b>Source selection</b>\" control and then"
        "press the \"<b>delete</b>\" button in the \"<b>Individual source operations</b>\" button group.<br><br>"

    "<b>4) Recompute the photometry of a particular source - </b><br>"
        "First \"select\" the required source by using the \"<b>Source selection</b>\" control and then"
        " press the \"<b>photometry</b>\" button, which will cause the \"<b>photometry window</b>\" to be displayed.<br><br>",


     0};     
                    
 

    HelpDlg *helpDlg = new HelpDlg( this, information);


    helpDlg->exec();
         
    delete helpDlg;  
 
}
/*************************************************************
*
************************************************************/
void OmSourceBrowser::mousePressEvent( QMouseEvent* event)
{
  
    if ( event->button() == RightButton )
    {   

        showHelpInformation();
    }



}



   


















