#include "OmSpinBox.h"
#include<qspinbox.h>
#include<qtooltip.h>
#include<qstring.h>
#include <vector>
#include <iostream>
   





OmSpinBox::OmSpinBox( QWidget *widget, QString text, vector<string> &theList, int current) : 
         QSpinBox( widget, text), _stringList( theList )
 
{



    QString text1 = text + "\n";

   
    for (unsigned i = 0; i < _stringList.size(); i++)
    {

        QString text2;
        text2.sprintf("%1d) %s\n", (i + 1), _stringList[i].c_str());
        text1 += text2;
    
    } 


    QToolTip::add( this, text1);
 
    setMinValue( 1 ); 
    setMaxValue( theList.size() );
    setValue( current );
    setWrapping( true );                                 


                              


};


OmSpinBox::OmSpinBox( QWidget *widget, QString text, int size, vector<string> &theList, int current) : 
         QSpinBox( widget, text), _stringList( theList )
 
{



    QString text1 = text + "\n";

   
    for (int i = 0; i < size; i++)
    {

        QString text2;
        text2.sprintf("%1d) %s\n", (i + 1), _stringList[i].c_str());
        text1 += text2;
    
    } 


    QToolTip::add( this, text1);
 
    setMinValue( 1 ); 
    setMaxValue( size );
    setValue( current );
    setWrapping( true );                                 


                              


};





/*************************************************************************************************
*
*
*
*************************************************************************************************/ 
OmSpinBox2::OmSpinBox2( QWidget *widget, QString text, 
                 float xmin, float xmax, float dx, 
                 float defaultVal, int current) : 
  QSpinBox( widget, text), _xmin(xmin), _xmax(xmax), _dx(dx), _defaultValue(defaultVal)
 
{

  
    int maxVal =  (int)(( xmax - xmin ) / dx + 0.00001 ) + 1; 
    setMinValue( 0 ); 
    setMaxValue( maxVal );
    setValue( current );
    setWrapping( true );                                 




};
